Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3597)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3600)
@@ -21,26 +21,31 @@
 !
 ! Current revisions:
-! ------------------
-! 
-! 
+! -----------------
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Code update to comply PALM coding rules            
+! Bug fix in par_dir_diff subroutine                 
+! Small fixes (corrected 'conastant', added 'Unused') 
+!
+! 3586 2018-11-30 13:20:29Z dom_dwd_user
 ! Changed character lenth of name in species_def and photols_def to 15
-! 
-! 
+!
 ! 3570 2018-11-27 17:44:21Z kanani
 ! resler:
 ! Break lines at 132 characters
-! 
+!
 ! 3543 2018-11-20 17:06:15Z suehring
 ! Remove tabs
-! 
+!
 ! 3542 2018-11-20 17:04:13Z suehring
 ! working precision added to make code Fortran 2008 conform
-! 
+!
 ! 3458 2018-10-30 14:51:23Z kanani
 ! from chemistry branch r3443, banzhafs, basit:
 ! replace surf_lsm_h%qv1(m) by q(k,j,i) for mixing ratio in chem_depo
+!
 ! bug fix in chem_depo: allow different surface fractions for one
 ! surface element and set lai to zero for non vegetated surfaces
@@ -212,54 +217,62 @@
  MODULE chemistry_model_mod
 
-    USE kinds,              ONLY: wp, iwp
-    USE indices,            ONLY: nz, nzb,nzt,nysg,nyng,nxlg,nxrg,                                 &
-                                 nys,nyn,nx,nxl,nxr,ny,wall_flags_0
-    USE pegrid,             ONLY: myid, threads_per_task
-
-   USE bulk_cloud_model_mod,                                               &
-        ONLY:  bulk_cloud_model
-
-    USE control_parameters, ONLY: bc_lr_cyc, bc_ns_cyc, dt_3d, humidity,                           &
-                                 initializing_actions, message_string,                             &
-                                 omega, tsc, intermediate_timestep_count,                          &
-                                 intermediate_timestep_count_max, max_pr_user,                     &
-                                 timestep_scheme, use_prescribed_profile_data, ws_scheme_sca  
-   USE arrays_3d,          ONLY: exner, hyp, pt, q, ql, rdf_sc, tend, zu
-    USE chem_gasphase_mod,  ONLY: nspec, spc_names, nkppctrl, nmaxfixsteps,                        &
-                                 t_steps, chem_gasphase_integrate, vl_dim,                         &
-                                 nvar, nreact,  atol, rtol, nphot, phot_names
-    USE cpulog,             ONLY: cpu_log, log_point
+    USE kinds,                                                                                     &
+         ONLY:  iwp, wp
+
+    USE indices,                                                                                   &
+         ONLY:  nz, nzb, nzt, nysg, nyng, nxlg, nxrg, nys, nyn, nx, nxl, nxr, ny, wall_flags_0
+
+    USE pegrid,                                                                                    &
+         ONLY: myid, threads_per_task
+
+    USE bulk_cloud_model_mod,                                                                      &
+         ONLY:  bulk_cloud_model
+
+    USE control_parameters,                                                                        &
+         ONLY:  bc_lr_cyc, bc_ns_cyc, dt_3d, humidity, initializing_actions, message_string,        &
+         omega, tsc, intermediate_timestep_count, intermediate_timestep_count_max,           &
+         max_pr_user, timestep_scheme, use_prescribed_profile_data, ws_scheme_sca         
+
+    USE arrays_3d,                                                                                 &
+         ONLY:  exner, hyp, pt, q, ql, rdf_sc, tend, zu
+
+    USE chem_gasphase_mod,                                                                         &
+         ONLY:  nspec, spc_names, nkppctrl, nmaxfixsteps, t_steps, chem_gasphase_integrate,         &
+         vl_dim, nvar, nreact,  atol, rtol, nphot, phot_names
+
+    USE cpulog,                                                                                    &
+         ONLY:  cpu_log, log_point
 
     USE chem_modules
- 
+
     USE statistics
 
-    IMPLICIT   NONE
+    IMPLICIT NONE
     PRIVATE
     SAVE
 
-    LOGICAL ::  nest_chemistry = .TRUE. !< flag for nesting mode of chemical species, independent on parent or not
-!
-!- Define chemical variables
+    LOGICAL ::  nest_chemistry = .TRUE.  !< flag for nesting mode of chemical species, independent on parent or not
+    !
+    !- Define chemical variables
     TYPE   species_def
-       CHARACTER(LEN=15)                                  :: name
-       CHARACTER(LEN=16)                                  :: unit
-       REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: conc
-       REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: conc_av
-       REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: conc_p
-       REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: tconc_m
-       REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:)           :: cssws_av           
-       REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:)           :: flux_s_cs
-       REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:)           :: diss_s_cs
-       REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:)         :: flux_l_cs
-       REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:)         :: diss_l_cs
-       REAL(kind=wp),ALLOCATABLE,DIMENSION(:)             :: conc_pr_init
+       CHARACTER(LEN=15)                            ::  name
+       CHARACTER(LEN=15)                            ::  unit
+       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     ::  conc
+       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     ::  conc_av
+       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     ::  conc_p
+       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     ::  tconc_m
+       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:)   ::  cssws_av           
+       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:)   ::  flux_s_cs
+       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:)   ::  diss_s_cs
+       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:) ::  flux_l_cs
+       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:) ::  diss_l_cs
+       REAL(kind=wp), ALLOCATABLE, DIMENSION(:)     ::  conc_pr_init
     END TYPE species_def
 
 
     TYPE   photols_def                                                            
-       CHARACTER(LEN=15)                                  :: name
-       CHARACTER(LEN=16)                                  :: unit
-       REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: freq
+       CHARACTER(LEN=15)                            :: name
+       CHARACTER(LEN=15)                            :: unit
+       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     :: freq
     END TYPE photols_def
 
@@ -269,97 +282,95 @@
 
 
-    TYPE(species_def),ALLOCATABLE,DIMENSION(:),TARGET, PUBLIC     :: chem_species
-    TYPE(photols_def),ALLOCATABLE,DIMENSION(:),TARGET, PUBLIC     :: phot_frequen  
-
-    REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: spec_conc_1
-    REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: spec_conc_2
-    REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: spec_conc_3
-    REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: spec_conc_av       
-    REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: freq_1
-
-    INTEGER,DIMENSION(nkppctrl)                           :: icntrl                            ! Fine tuning kpp
-    REAL(kind=wp),DIMENSION(nkppctrl)                     :: rcntrl                            ! Fine tuning kpp
-    LOGICAL :: decycle_chem_lr    = .FALSE.
-    LOGICAL :: decycle_chem_ns    = .FALSE.
+    TYPE(species_def), ALLOCATABLE, DIMENSION(:), TARGET, PUBLIC ::  chem_species
+    TYPE(photols_def), ALLOCATABLE, DIMENSION(:), TARGET, PUBLIC ::  phot_frequen  
+
+    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_1
+    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_2
+    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_3
+    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_av       
+    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  freq_1
+
+    INTEGER, DIMENSION(nkppctrl)                           ::  icntrl                            !< Fine tuning kpp
+    REAL(kind=wp), DIMENSION(nkppctrl)                     ::  rcntrl                            !< Fine tuning kpp
+    LOGICAL ::  decycle_chem_lr    = .FALSE.
+    LOGICAL ::  decycle_chem_ns    = .FALSE.
     CHARACTER (LEN=20), DIMENSION(4) ::  decycle_method = &
-                  (/'dirichlet','dirichlet','dirichlet','dirichlet'/)
-                                 !< Decycling method at horizontal boundaries, 
-                                 !< 1=left, 2=right, 3=south, 4=north
-                                 !< dirichlet = initial size distribution and 
-                                 !< chemical composition set for the ghost and 
-                                 !< first three layers
-                                 !< neumann = zero gradient
-
-    REAL(kind=wp), PUBLIC :: cs_time_step = 0._wp
-    CHARACTER(10), PUBLIC :: photolysis_scheme
-                                         ! 'constant',
-                                         ! 'simple' (Simple parameterisation from MCM, Saunders et al., 2003, Atmos. Chem. Phys., 3, 161-180
-                                         ! 'fastj'  (Wild et al., 2000, J. Atmos. Chem., 37, 245-282) STILL NOT IMPLEMENTED
-
-    
-    !-----------------------------------------------------------------------
-    ! Parameter needed for Deposition calculation using DEPAC model (van Zanten et al., 2010)
-    !
-    INTEGER(iwp), PARAMETER :: nlu_dep = 15                   ! Number of DEPAC landuse classes (lu's)
-    INTEGER(iwp), PARAMETER :: ncmp = 10                      ! Number of DEPAC gas components
-    !------------------------------------------------------------------------
-    ! DEPAC landuse classes as defined in LOTOS-EUROS model v2.1                              
-    !
-    INTEGER(iwp)  ::  ilu_grass              = 1        
-    INTEGER(iwp)  ::  ilu_arable             = 2        
-    INTEGER(iwp)  ::  ilu_permanent_crops    = 3         
-    INTEGER(iwp)  ::  ilu_coniferous_forest  = 4         
-    INTEGER(iwp)  ::  ilu_deciduous_forest   = 5         
-    INTEGER(iwp)  ::  ilu_water_sea          = 6        
-    INTEGER(iwp)  ::  ilu_urban              = 7        
-    INTEGER(iwp)  ::  ilu_other              = 8  
-    INTEGER(iwp)  ::  ilu_desert             = 9  
-    INTEGER(iwp)  ::  ilu_ice                = 10 
-    INTEGER(iwp)  ::  ilu_savanna            = 11 
-    INTEGER(iwp)  ::  ilu_tropical_forest    = 12 
-    INTEGER(iwp)  ::  ilu_water_inland       = 13 
-    INTEGER(iwp)  ::  ilu_mediterrean_scrub  = 14 
-    INTEGER(iwp)  ::  ilu_semi_natural_veg   = 15 
-    ! 
-    !--------------------------------------------------------------------------
-    ! NH3/SO2 ratio regimes:
-    INTEGER, PARAMETER  ::  iratns_low  = 1       ! low ratio NH3/SO2
-    INTEGER, PARAMETER  ::  iratns_high = 2       ! high ratio NH3/SO2
-    INTEGER, PARAMETER  ::  iratns_very_low = 3   ! very low ratio NH3/SO2
-    ! Default:
-    INTEGER, PARAMETER  ::  iratns_default = iratns_low
-    !
-    ! Set alpha for f_light (4.57 is conversion factor from 1./(mumol m-2 s-1) naar W m-2
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: alpha   = &
-      (/0.009,0.009, 0.009,0.006,0.006, -999., -999.,0.009,-999.,-999.,0.009,0.006,-999.,0.009,0.008/)*4.57
-    !
-    ! Set temperatures per land use for F_temp
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: Tmin = &
-      (/12.0, 12.0,  12.0,  0.0,  0.0, -999., -999., 12.0, -999., -999., 12.0,  0.0, -999., 12.0,  8.0/)
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: Topt = &
-      (/26.0, 26.0,  26.0, 18.0, 20.0, -999., -999., 26.0, -999., -999., 26.0, 20.0, -999., 26.0, 24.0 /)
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: Tmax = &
-      (/40.0, 40.0,  40.0, 36.0, 35.0, -999., -999., 40.0, -999., -999., 40.0, 35.0, -999., 40.0, 39.0 /)
-    !
-    ! Set F_min:
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: F_min = &
-      (/0.01, 0.01,  0.01, 0.1,  0.1,   -999., -999.,0.01, -999.,-999.,0.01,0.1,-999.,0.01, 0.04/)
-    
-    ! Set maximal conductance (m/s)
-    ! (R T/P) = 1/41000 mmol/m3 is given for 20 deg C to go from  mmol O3/m2/s to m/s
-    ! Could be refined to a function of T and P. in Jones
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: g_max = &
-      (/270., 300.,  300., 140., 150.,  -999., -999.,270., -999.,-999.,270., 150.,-999.,300., 422./)/41000
-    !
-    ! Set max, min for vapour pressure deficit vpd;
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: vpd_max = &
-      (/1.3,  0.9,   0.9,  0.5,  1.0,   -999., -999.,1.3,  -999.,-999.,1.3,1.0,  -999.,0.9, 2.8/) 
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: vpd_min = &
-      (/3.0,  2.8,   2.8,  3.0,  3.25,  -999., -999.,3.0,  -999.,-999.,3.0,3.25, -999.,2.8, 4.5/) 
-    !
-    !  
-    !------------------------------------------------------------------------
-
-    
+         (/'dirichlet','dirichlet','dirichlet','dirichlet'/)
+                              !< Decycling method at horizontal boundaries, 
+                              !< 1=left, 2=right, 3=south, 4=north
+                              !< dirichlet = initial size distribution and 
+                              !< chemical composition set for the ghost and 
+                              !< first three layers
+                              !< neumann = zero gradient
+
+    REAL(kind=wp), PUBLIC ::  cs_time_step = 0._wp
+    CHARACTER(10), PUBLIC ::  photolysis_scheme
+                              !< 'constant',
+                              !< 'simple' (Simple parameterisation from MCM, Saunders et al., 2003, Atmos. Chem. Phys., 3, 161-180
+                              !< 'fastj'  (Wild et al., 2000, J. Atmos. Chem., 37, 245-282) STILL NOT IMPLEMENTED
+
+
+    !
+    !-- Parameter needed for Deposition calculation using DEPAC model (van Zanten et al., 2010)
+    !
+    INTEGER(iwp), PARAMETER ::  nlu_dep = 15                   !< Number of DEPAC landuse classes (lu's)
+    INTEGER(iwp), PARAMETER ::  ncmp = 10                      !< Number of DEPAC gas components
+    INTEGER(iwp), PARAMETER ::  nposp = 69                     !< Number of possible species for deposition
+    !
+    !-- DEPAC landuse classes as defined in LOTOS-EUROS model v2.1                              
+    INTEGER(iwp) ::  ilu_grass              = 1        
+    INTEGER(iwp) ::  ilu_arable             = 2        
+    INTEGER(iwp) ::  ilu_permanent_crops    = 3         
+    INTEGER(iwp) ::  ilu_coniferous_forest  = 4         
+    INTEGER(iwp) ::  ilu_deciduous_forest   = 5         
+    INTEGER(iwp) ::  ilu_water_sea          = 6        
+    INTEGER(iwp) ::  ilu_urban              = 7        
+    INTEGER(iwp) ::  ilu_other              = 8  
+    INTEGER(iwp) ::  ilu_desert             = 9  
+    INTEGER(iwp) ::  ilu_ice                = 10 
+    INTEGER(iwp) ::  ilu_savanna            = 11 
+    INTEGER(iwp) ::  ilu_tropical_forest    = 12 
+    INTEGER(iwp) ::  ilu_water_inland       = 13 
+    INTEGER(iwp) ::  ilu_mediterrean_scrub  = 14 
+    INTEGER(iwp) ::  ilu_semi_natural_veg   = 15 
+
+    !
+    !-- NH3/SO2 ratio regimes:
+    INTEGER(iwp), PARAMETER ::  iratns_low      = 1       !< low ratio NH3/SO2
+    INTEGER(iwp), PARAMETER ::  iratns_high     = 2       !< high ratio NH3/SO2
+    INTEGER(iwp), PARAMETER ::  iratns_very_low = 3       !< very low ratio NH3/SO2
+    !
+    !-- Default:
+    INTEGER, PARAMETER ::  iratns_default = iratns_low
+    !
+    !-- Set alpha for f_light (4.57 is conversion factor from 1./(mumol m-2 s-1) to W m-2
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  alpha   =(/ 0.009, 0.009, 0.009, 0.006, 0.006, -999., -999., 0.009, -999.,      &
+         -999., 0.009, 0.006, -999., 0.009, 0.008/)*4.57
+    !
+    !-- Set temperatures per land use for f_temp
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  tmin = (/ 12.0, 12.0,  12.0,  0.0,  0.0, -999., -999., 12.0, -999., -999.,      &
+         12.0,  0.0, -999., 12.0,  8.0/)
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  topt = (/ 26.0, 26.0,  26.0, 18.0, 20.0, -999., -999., 26.0, -999., -999.,      &
+         26.0, 20.0, -999., 26.0, 24.0 /)
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  tmax = (/ 40.0, 40.0,  40.0, 36.0, 35.0, -999., -999., 40.0, -999., -999.,      &
+         40.0, 35.0, -999., 40.0, 39.0 /)
+    !
+    !-- Set f_min:
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  f_min = (/ 0.01, 0.01, 0.01, 0.1, 0.1, -999., -999., 0.01, -999., -999., 0.01,  &
+         0.1, -999., 0.01, 0.04/)
+
+    !
+    !-- Set maximal conductance (m/s)
+    !-- (R T/P) = 1/41000 mmol/m3 is given for 20 deg C to go from  mmol O3/m2/s to m/s
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  g_max = (/ 270., 300., 300., 140., 150., -999., -999., 270., -999., -999.,      &
+         270., 150., -999., 300., 422./)/41000
+    !
+    !-- Set max, min for vapour pressure deficit vpd
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  vpd_max = (/1.3, 0.9, 0.9, 0.5, 1.0, -999., -999., 1.3, -999., -999., 1.3,      &
+         1.0, -999., 0.9, 2.8/) 
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  vpd_min = (/3.0, 2.8, 2.8, 3.0, 3.25, -999., -999., 3.0, -999., -999., 3.0,     &
+         3.25, -999., 2.8, 4.5/) 
+
+
     PUBLIC nest_chemistry
     PUBLIC nspec
@@ -369,5 +380,6 @@
     PUBLIC spec_conc_2  
 
-!-  Interface section
+    !    
+    !-- Interface section
     INTERFACE chem_3d_data_averaging
        MODULE PROCEDURE chem_3d_data_averaging 
@@ -516,13 +528,13 @@
     END INTERFACE get_rb_cell
 
-    
+
 
     PUBLIC chem_3d_data_averaging, chem_boundary_conds, chem_check_data_output, &
-           chem_check_data_output_pr, chem_check_parameters,                    &
-           chem_data_output_2d, chem_data_output_3d, chem_data_output_mask,     &
-           chem_define_netcdf_grid, chem_header, chem_init,                     &
-           chem_init_profiles, chem_integrate, chem_parin,                      &
-           chem_prognostic_equations, chem_rrd_local,                           &
-           chem_statistics, chem_swap_timelevel, chem_wrd_local, chem_depo 
+         chem_check_data_output_pr, chem_check_parameters,                    &
+         chem_data_output_2d, chem_data_output_3d, chem_data_output_mask,     &
+         chem_define_netcdf_grid, chem_header, chem_init,                     &
+         chem_init_profiles, chem_integrate, chem_parin,                      &
+         chem_prognostic_equations, chem_rrd_local,                           &
+         chem_statistics, chem_swap_timelevel, chem_wrd_local, chem_depo 
 
 
@@ -530,122 +542,122 @@
  CONTAINS
 
-!
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine for averaging 3D data of chemical species. Due to the fact that 
-!> the averaged chem arrays are allocated in chem_init, no if-query concerning
-!> the allocation is required (in any mode). Attention: If you just specify an 
-!> averaged output quantity in the _p3dr file during restarts the first output
-!> includes the time between the beginning of the restart run and the first
-!> output time (not necessarily the whole averaging_interval you have 
-!> specified in your _p3d/_p3dr file )
-!------------------------------------------------------------------------------!
-
-    SUBROUTINE chem_3d_data_averaging ( mode, variable )
-
-       USE control_parameters
-
-       USE indices
-
-       USE kinds
-
-       USE surface_mod,                                                         &
-          ONLY: surf_def_h, surf_lsm_h, surf_usm_h   
-  
-       IMPLICIT NONE
- 
-       CHARACTER (LEN=*) ::  mode    !< 
-       CHARACTER (LEN=*) :: variable !< 
- 
-       LOGICAL      ::  match_def !< flag indicating natural-type surface
-       LOGICAL      ::  match_lsm !< flag indicating natural-type surface
-       LOGICAL      ::  match_usm !< flag indicating urban-type surface
-
-       INTEGER(iwp) ::  i                  !< grid index x direction
-       INTEGER(iwp) ::  j                  !< grid index y direction
-       INTEGER(iwp) ::  k                  !< grid index z direction
-       INTEGER(iwp) ::  m                  !< running index surface type
-       INTEGER(iwp) :: lsp                 !< running index for chem spcs
-
-
-       IF ( mode == 'allocate' )  THEN
-          DO lsp = 1, nspec
-             IF ( TRIM(variable(1:3)) == 'kc_' .AND. &
-                  TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
-                chem_species(lsp)%conc_av = 0.0_wp
-             ENDIF
-          ENDDO
-
-       ELSEIF ( mode == 'sum' )  THEN
-
-          DO lsp = 1, nspec
-             IF ( TRIM(variable(1:3)) == 'kc_' .AND. &
-                  TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                          chem_species(lsp)%conc_av(k,j,i) = chem_species(lsp)%conc_av(k,j,i) + &
-                                                             chem_species(lsp)%conc(k,j,i)
-                      ENDDO
+ !
+ !------------------------------------------------------------------------------!
+ !
+ ! Description:
+ ! ------------
+ !> Subroutine for averaging 3D data of chemical species. Due to the fact that 
+ !> the averaged chem arrays are allocated in chem_init, no if-query concerning
+ !> the allocation is required (in any mode). Attention: If you just specify an 
+ !> averaged output quantity in the _p3dr file during restarts the first output
+ !> includes the time between the beginning of the restart run and the first
+ !> output time (not necessarily the whole averaging_interval you have 
+ !> specified in your _p3d/_p3dr file )
+ !------------------------------------------------------------------------------!
+
+ SUBROUTINE chem_3d_data_averaging( mode, variable )
+
+    USE control_parameters
+
+    USE indices
+
+    USE kinds
+
+    USE surface_mod,                                                         &
+         ONLY:  surf_def_h, surf_lsm_h, surf_usm_h   
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*) ::  mode    !< 
+    CHARACTER (LEN=*) :: variable !< 
+
+    LOGICAL      ::  match_def !< flag indicating natural-type surface
+    LOGICAL      ::  match_lsm !< flag indicating natural-type surface
+    LOGICAL      ::  match_usm !< flag indicating urban-type surface
+
+    INTEGER(iwp) ::  i                  !< grid index x direction
+    INTEGER(iwp) ::  j                  !< grid index y direction
+    INTEGER(iwp) ::  k                  !< grid index z direction
+    INTEGER(iwp) ::  m                  !< running index surface type
+    INTEGER(iwp) :: lsp                 !< running index for chem spcs
+
+
+    IF ( mode == 'allocate' )  THEN
+       DO lsp = 1, nspec
+          IF ( TRIM(variable(1:3)) == 'kc_' .AND. &
+               TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
+             chem_species(lsp)%conc_av = 0.0_wp
+          ENDIF
+       ENDDO
+
+    ELSEIF ( mode == 'sum' )  THEN
+
+       DO lsp = 1, nspec
+          IF ( TRIM(variable(1:3)) == 'kc_' .AND. &
+               TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      chem_species(lsp)%conc_av(k,j,i) = chem_species(lsp)%conc_av(k,j,i) + &
+                           chem_species(lsp)%conc(k,j,i)
                    ENDDO
                 ENDDO
-             ELSEIF ( TRIM(variable(4:)) == TRIM('cssws*') )        THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <=               &
-                                  surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <=                  &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=                  &
-                                  surf_usm_h%end_index(j,i)
-
-                      IF ( match_def )  THEN
-                         m = surf_def_h(0)%end_index(j,i)
-                         chem_species(lsp)%cssws_av(j,i) =                        &
-                                                chem_species(lsp)%cssws_av(j,i) + &
-                                                surf_def_h(0)%cssws(lsp,m)
-                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         chem_species(lsp)%cssws_av(j,i) =                        &
-                                                chem_species(lsp)%cssws_av(j,i) + &
-                                                surf_lsm_h%cssws(lsp,m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         chem_species(lsp)%cssws_av(j,i) =                        &
-                                                chem_species(lsp)%cssws_av(j,i) + &
-                                                surf_usm_h%cssws(lsp,m)
-                      ENDIF
+             ENDDO
+          ELSEIF ( TRIM(variable(4:)) == TRIM('cssws*') )        THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   match_def = surf_def_h(0)%start_index(j,i) <=               &
+                        surf_def_h(0)%end_index(j,i)
+                   match_lsm = surf_lsm_h%start_index(j,i) <=                  &
+                        surf_lsm_h%end_index(j,i)
+                   match_usm = surf_usm_h%start_index(j,i) <=                  &
+                        surf_usm_h%end_index(j,i)
+
+                   IF ( match_def )  THEN
+                      m = surf_def_h(0)%end_index(j,i)
+                      chem_species(lsp)%cssws_av(j,i) =                        &
+                           chem_species(lsp)%cssws_av(j,i) + &
+                           surf_def_h(0)%cssws(lsp,m)
+                   ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
+                      m = surf_lsm_h%end_index(j,i)
+                      chem_species(lsp)%cssws_av(j,i) =                        &
+                           chem_species(lsp)%cssws_av(j,i) + &
+                           surf_lsm_h%cssws(lsp,m)
+                   ELSEIF ( match_usm )  THEN
+                      m = surf_usm_h%end_index(j,i)
+                      chem_species(lsp)%cssws_av(j,i) =                        &
+                           chem_species(lsp)%cssws_av(j,i) + &
+                           surf_usm_h%cssws(lsp,m)
+                   ENDIF
+                ENDDO
+             ENDDO
+          ENDIF
+       ENDDO
+
+    ELSEIF ( mode == 'average' )  THEN
+       DO lsp = 1, nspec
+          IF ( TRIM(variable(1:3)) == 'kc_' .AND. &
+               TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      chem_species(lsp)%conc_av(k,j,i) = chem_species(lsp)%conc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
-             ENDIF
-          ENDDO
- 
-       ELSEIF ( mode == 'average' )  THEN
-          DO lsp = 1, nspec
-             IF ( TRIM(variable(1:3)) == 'kc_' .AND. &
-                  TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                          chem_species(lsp)%conc_av(k,j,i) = chem_species(lsp)%conc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
+             ENDDO
+
+          ELSEIF (TRIM(variable(4:)) == TRIM('cssws*') )            THEN
+             DO i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   chem_species(lsp)%cssws_av(j,i) = chem_species(lsp)%cssws_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
-
-             ELSEIF (TRIM(variable(4:)) == TRIM('cssws*') )            THEN
-                DO i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                        chem_species(lsp)%cssws_av(j,i) = chem_species(lsp)%cssws_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                   CALL exchange_horiz_2d( chem_species(lsp)%cssws_av, nbgp )                 
-             ENDIF
-          ENDDO
-          
-       ENDIF     
-
-    END SUBROUTINE chem_3d_data_averaging
+             ENDDO
+             CALL exchange_horiz_2d( chem_species(lsp)%cssws_av, nbgp )                 
+          ENDIF
+       ENDDO
+
+    ENDIF
+
+ END SUBROUTINE chem_3d_data_averaging
 
 !    
